﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using SoundPlayStreamTest;
using System.Diagnostics;
using System.IO;



namespace playwav
{
    class Program
    {
        [DllImport("Kernel32.dll")]
        extern public static uint CopyMemory(WAVHDR Destination, ref byte Source, uint Length);
        [DllImport("Kernel32.dll")]
        extern public static uint CopyMemory(ref byte Destination, ref short Source, uint Length);
        [DllImport("Kernel32.dll")]
        extern public static uint CopyMemory(ref byte Destination, WAVHDR Source, uint Length);

        static void Kakunin(string wav)
        {
            System.Media.SoundPlayer player2 = new System.Media.SoundPlayer(wav);
            player2.Play();
            do
            {

            } while (Console.KeyAvailable != true);
            Console.ReadLine();
            player2.Stop();
        }

      
        static void SubRand(ref byte[] bs,int offset,int size)
        {
            //  作る
            byte[] cs = (byte[])bs.Clone();

            Random cRandom = new Random();
            for (int i = offset; i < offset + size; i++)
            {
                cs[i] = (byte)cRandom.Next(0, 255);
            }
            string outputwav = "rand.wav";
            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        //  ２バイト毎にＬＲ　片方全部削る
        static void SubRnomi(ref byte[] bs, int offset, int size)
        {
            string outputwav = "rnomi.wav";
            //  作る
            //            byte[] cs = bs.Clone();
            //            byte[] cs=new byte[](bs.Length);
            byte[] cs = (byte[])bs.Clone();
            for (int i = offset; i < offset + size; i++)
            {
                if (i % 4 == 0 || i % 4 == 1)
                {
                    cs[i] = 0;
                }
            }
            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }


        // 440Hz 
        static void SubSin(ref byte[] bs, int offset, int size,int bytespersec)
        {
            // bytespersec
            // 440 cnt per sec
            // 4byte  
            // 440 cnt vs bytespersec
            // 何cntか    4byte

            double cnt = 440.0 * 4.0 / (double)bytespersec;
            double pcnt = cnt * 2.0 * Math.PI;

            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "sin.wav";
 
            int size2 = size - offset;
            size2 = size2 / 4;

            // 直いれてく
            for (int i = 0; i < size2; i++)
            {

                short v= (short)(10000.0 * Math.Sin((double)i*pcnt));
                byte [] vb=BitConverter.GetBytes(v);
                int cptr = offset + i * 4;

                cs[cptr + 0] = vb[0];
                cs[cptr + 1] = vb[1];
                cs[cptr + 2] = vb[0];
                cs[cptr + 3] = vb[1];

            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        static short getKukei(double theta)
        {
            double v = Math.Sin(theta);
            if (v > 0.0)
            {
                return (10000);
            }
            else
            {
                return (-10000);
            }
        }

        // 440Hz Kukei
        static void SubKukei(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "kukei440.wav";

            // 角度でいえば
            // bytespersec 1秒　　　　　　　440回転  440*PI*2
            // 4byte       bytespesec/4秒　　　　　　
            double cnt = 440.0 * 4.0 / (double)bytespersec;
            double pcnt = cnt * 2.0 * Math.PI;

            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;
            double theta = 0.0;
            for (int i = 0; i < size2; i++)
            {
                short v = getKukei(theta);
                byte[] vb = BitConverter.GetBytes(v);
                int cptr = offset + i * 4;

                cs[cptr + 0] = vb[0];
                cs[cptr + 1] = vb[1];
                cs[cptr + 2] = vb[0];
                cs[cptr + 3] = vb[1];

                theta += pcnt;
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        // 440Hz Kukeiで音程さがる
        static void SubKukeiSagari(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "kukeiSagari.wav";

            // 角度でいえば
            // bytespersec 1秒　　　　　　　440回転  440*PI*2
            // 4byte       bytespesec/4秒　　　　　　
            double cnt = 8.0 * 440.0 * 4.0 / (double)bytespersec;
            double pcnt = cnt * 2.0 * Math.PI;
            double henka = -400 * 440.0 * 4.0 / (double)bytespersec / (double)bytespersec;

            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;
            double theta = 0.0;
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;

                if (pcnt >= 0.0)
                {
                    short v = getKukei(theta);
                    byte[] vb = BitConverter.GetBytes(v);

                    cs[cptr + 0] = vb[0];
                    cs[cptr + 1] = vb[1];
                    cs[cptr + 2] = vb[0];
                    cs[cptr + 3] = vb[1];
                    theta += pcnt;
                    pcnt += henka;
                }
                else
                {
                    cs[cptr + 0] =
                    cs[cptr + 1] =
                    cs[cptr + 2] =
                    cs[cptr + 3] = 0;
                }
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        // Kukei　ランダム音程
        static void SubSH(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "SH.wav";

            // 角度でいえば
            // bytespersec 1秒　　　　　　　440回転  440*PI*2
            // 4byte       bytespesec/4秒　　　　　　
//            double cnt = 8.0 * 440.0 * 4.0 / (double)bytespersec;
//            double pcnt = cnt * 2.0 * Math.PI;


            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;

            Random r = new Random();
            double pcnt=0.0;
            double theta = 0.0;
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;

                if (i % 10000 == 0)
                {
                    int hz=r.Next(220, 1660);
                    pcnt = 2.0 * Math.PI * hz * 4.0 / (double)bytespersec;
                }

                short v = getKukei(theta);
                byte[] vb = BitConverter.GetBytes(v);

                cs[cptr + 0] = vb[0];
                cs[cptr + 1] = vb[1];
                cs[cptr + 2] = vb[0];
                cs[cptr + 3] = vb[1];

                theta += pcnt;
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        static void SubIchion(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "ichion.wav";

            // 角度でいえば
            // bytespersec 1秒　　　　　　　440回転  440*PI*2
            // 4byte       bytespesec/4秒　　　　　　
            //            double cnt = 8.0 * 440.0 * 4.0 / (double)bytespersec;
            //            double pcnt = cnt * 2.0 * Math.PI;

            //  440 880
            //  


            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;

            Random r = new Random();
            double pcnt = 0.0;
            double theta = 0.0;
            double hz = 220.0;
            pcnt = 2.0 * Math.PI * hz * 4.0 / (double)bytespersec;
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;

                if (i!=0 && (i % 10000 == 0))
                {
                    hz *= 1.122462;
                    pcnt = 2.0 * Math.PI * hz * 4.0 / (double)bytespersec;
                }

                short v = getKukei(theta);
                byte[] vb = BitConverter.GetBytes(v);

                cs[cptr + 0] = vb[0];
                cs[cptr + 1] = vb[1];
                cs[cptr + 2] = vb[0];
                cs[cptr + 3] = vb[1];

                theta += pcnt;
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        static void SubHosoiMado(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "HosoiMado.wav";


            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;

            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;
                int j = i % 5000;

                if (j < 2000)
                {
                    //  そのまま
                }
                else
                {
                    cs[cptr + 0] = 0;
                    cs[cptr + 1] = 0;
                    cs[cptr + 2] = 0;
                    cs[cptr + 3] = 0;
                }
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        static void SubBai(ref byte[] bs, int offset, int size, int bytespersec)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "Bai.wav";


            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;

            int bai = 3;
            for (int i = 0; i < size2; i++)
            {
                int bptr = offset + ((i * 4 * bai) % size2);
                int cptr = offset + i * 4;

                cs[cptr + 0] = bs[bptr + 0];
                cs[cptr + 1] = bs[bptr + 1];
                cs[cptr + 2] = bs[bptr + 2];
                cs[cptr + 3] = bs[bptr + 3];

            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        static void SubChi(ref byte[] bs, int offset, int size, int bytespersec,bool flag,double ratio,string filename)
        {
            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = filename;

            // ステレオあわせてサンプル単位
            int size2 = size - offset;
            size2 = size2 / 4;

            double dtempo = (double)bytespersec * ratio * 0.25;
            int tempo = (int)dtempo;
            int haba = 500;

            Random r = new Random();
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;
                if (i % tempo < haba)
                {
                    cs[cptr + 0] = (byte)r.Next(0, 255);
                    cs[cptr + 1] = (byte)r.Next(0, 255);
                    cs[cptr + 2] = (byte)r.Next(0, 255);
                    cs[cptr + 3] = (byte)r.Next(0, 255);
                }
                else
                {
                    if (flag)
                    {
                        cs[cptr + 0] = 0;
                        cs[cptr + 1] = 0;
                        cs[cptr + 2] = 0;
                        cs[cptr + 3] = 0;
                    }
                }
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        // 440Hz 
        // ステレオで変な感じにしたがちっとも気づかない
        static void SubSin2(ref byte[] bs, int offset, int size, int bytespersec)
        {
            // bytespersec
            // 440 cnt per sec
            // 4byte  
            // 440 cnt vs bytespersec
            // 何cntか    4byte

            double cnt = 440.0 * 4.0 / (double)(bytespersec*2.0);
            double pcnt = cnt * 2.0 * Math.PI;

            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "sin2.wav";

            int size2 = size - offset;
            size2 = size2 / 2;

            // 直いれてく
            for (int i = 0; i < size2; i++)
            {
                short v = (short)(10000.0 * Math.Sin((double)i * pcnt));
                byte[] vb = BitConverter.GetBytes(v);
                int cptr = offset + i * 2;

                cs[cptr + 0] = vb[0];
                cs[cptr + 1] = vb[1];
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        //880-440
        static void SubPyu(ref byte[] bs, int offset, int size, int bytespersec)
        {
            double cnt = 8.0*440.0 * 4.0 / (double)bytespersec;
            double pcnt = cnt * 2.0 * Math.PI;
            double henka = -200*440.0 * 4.0 / (double)bytespersec / (double)bytespersec;

            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "pyu.wav";

            int size2 = size - offset;
            size2 = size2 / 4;

            // 直いれてく
            // ステレオ１サンプルずつ
            double theta = 0.0;
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;
                if (pcnt > 0.0)
                {
                    short v = (short)(10000.0 * Math.Sin(theta));
                    byte[] vb = BitConverter.GetBytes(v);

                    cs[cptr + 0] = vb[0];
                    cs[cptr + 1] = vb[1];
                    cs[cptr + 2] = vb[0];
                    cs[cptr + 3] = vb[1];

                    pcnt += henka;
                    theta += pcnt;
                }
                else
                {
                    cs[cptr + 0] = 0;
                    cs[cptr + 1] = 0;
                    cs[cptr + 2] = 0;
                    cs[cptr + 3] = 0;
                }
            }

            File.WriteAllBytes(outputwav, cs);
            Kakunin(outputwav);
        }

        //880-440
        static void SubPoon(ref byte[] bs, int offset, int size, int bytespersec,WAVHDR wavhdr)
        {
            double cnt = 2.0 * 440.0 * 4.0 / (double)bytespersec;
            double pcnt = cnt * 2.0 * Math.PI;
            double henka = 200 * 440.0 * 4.0 / (double)bytespersec / (double)bytespersec;

            //  とりあえず全部コピー
            byte[] cs = (byte[])bs.Clone();
            string outputwav = "poon.wav";

            int size2 = size - offset;
            size2 = size2 / 4;

            // 直いれてく
            // ステレオ１サンプルずつ
            double theta = 0.0;
            for (int i = 0; i < size2; i++)
            {
                int cptr = offset + i * 4;
                double power = 10000.0;
                if (i < 20000)
                {
                    power = 10000.0;
                }
                else
                { 
                    // 20000 10000
                    // 23000     0
                    power = -10000.0 * (i - 20000.0) / (23000.0 - 20000.0) + 10000.0;
                }
                if (i<23000)
                {
                    short v = (short)(power * Math.Sin(theta));
                    byte[] vb = BitConverter.GetBytes(v);

                    cs[cptr + 0] = vb[0];
                    cs[cptr + 1] = vb[1];
                    cs[cptr + 2] = vb[0];
                    cs[cptr + 3] = vb[1];

                    pcnt += henka;
                    theta += pcnt;
                }
                else
                {
                    cs[cptr + 0] = 0;
                    cs[cptr + 1] = 0;
                    cs[cptr + 2] = 0;
                    cs[cptr + 3] = 0;
                }
            }

            /// あらたえめて整形
            wavhdr.size = 23000 * 4;
            wavhdr.fileSize = wavhdr.size + 44;

            byte[] saigo = new byte[wavhdr.fileSize];
            CopyMemory(ref saigo[0], wavhdr, 44);
            for (int i = 0; i < 23000 * 4; i++)
            {
                saigo[i + 44] = cs[i + 44];
            }

            File.WriteAllBytes(outputwav, saigo);
            Kakunin(outputwav);
        }


        static void TestSeq(int ptn,bool slope)
        {
            string inputwav = "sample.wav";
            // ■ファイルオープン＆オールコピー           
            System.IO.FileStream fs = new System.IO.FileStream(
                inputwav,
                System.IO.FileMode.Open,
                System.IO.FileAccess.Read);
            byte[] bs = new byte[fs.Length];
            fs.Read(bs, 0, bs.Length);
            fs.Close();
            //  確認
            WAVHDR wavhdr = new WAVHDR();
            CopyMemory(wavhdr, ref bs[0], (uint)Marshal.SizeOf(wavhdr));

            Debug.WriteLine("bytespersec=" + wavhdr.bytespersec.ToString());
            int samplepersec = (int)wavhdr.bytespersec / 4;
            Debug.WriteLine("samplepersec=" + samplepersec.ToString());

            SeqData seqdata = null;
            switch (ptn)
            {
                case 0: seqdata = SeqData.GetSampleDoremi(); break;
                case 1: seqdata = SeqData.GetSampleRa3(); break;
                case 2: seqdata = SeqData.GetSamplePipipi(); break;
                case 3: seqdata = SeqData.GetSampleKyoku(); break;
                case 4: seqdata = SeqData.GetSampleKaeru(); break;
            }

            
            seqdata.Disp();
            List<double> ld = null;

            if (slope)
            {
                ld=seqdata.ToNotes2(1.0 / (double)samplepersec);
            }
            else
            {
                ld=seqdata.ToNotes(1.0 / (double)samplepersec);
            }

//            List<double> ld = seqdata.ToNotes(1.0 / (double)100.0;
/*            foreach (double d in ld)
            {
                Debug.Write(d.ToString() + ",");
            }
            Debug.WriteLine("");
*/
            int bytecnt=ld.Count*4;
            byte[] cs=new byte[bytecnt];

            // pyuに習う
            double theta = 0.0;

            int ind=0;
            foreach (double d in ld)
            {
                short v = getKukei(theta);
                byte[] vb = BitConverter.GetBytes(v);

                cs[ind++] = vb[0];
                cs[ind++] = vb[1];
                cs[ind++] = vb[0];
                cs[ind++] = vb[1];

                double cnt = d / samplepersec;
                double pcnt = cnt * 2.0 * Math.PI;
                theta += pcnt;
            }

            wavhdr.size = (uint)bytecnt;
            wavhdr.fileSize = 44 + wavhdr.size;

            byte[] saigo = new byte[wavhdr.fileSize];

            CopyMemory(ref saigo[0], wavhdr, 44);
            cs.CopyTo(saigo, 44);

            string outputwav = "seq_" + ptn.ToString() + "_" + slope.ToString() + ".wav";
            File.WriteAllBytes(outputwav, saigo);
            Kakunin(outputwav);
        
        }

        static void Iroiro()
        {
            string inputwav="sample.wav";

            // ■ファイルオープン＆オールコピー           
            System.IO.FileStream fs = new System.IO.FileStream(
                inputwav,
                System.IO.FileMode.Open,
                System.IO.FileAccess.Read);
            byte[] bs = new byte[fs.Length];
            fs.Read(bs, 0, bs.Length);
            fs.Close();

            
            //  確認
            WAVHDR wavhdr=new WAVHDR();
            CopyMemory(wavhdr, ref bs[0], (uint)Marshal.SizeOf(wavhdr));

            //  waveファイルチェック

            if (wavhdr.wave == 0x45564157)
            {
                Debug.WriteLine("WAVE!");
            }

            if (wavhdr.formatid == 0x01)
            {
                Debug.WriteLine("WAVE_FORMAT_PCM!");
            }

            int size = (int)wavhdr.size;
            Debug.WriteLine("size=" + wavhdr.size.ToString()+":"+wavhdr.size.ToString("X"));
//1,216,512 バイト
            string str = System.Text.Encoding.UTF8.GetString(bs,36,4);
            Debug.WriteLine(str);

            int offset=0;
            if (str.CompareTo("data") == 0)
            {
                Debug.WriteLine("dataだ");
                offset = 44;
            }
            
            for (int i = 0; i < offset; i++)
            {
                Debug.Write(bs[i].ToString("X2"));
            }
            
            
            Debug.WriteLine("");

            for (int i = offset; i < offset+100; i++)
            {
                Debug.Write(bs[i].ToString("X2"));
            }

            Debug.WriteLine("");


            Debug.WriteLine("channel=" + wavhdr.channel.ToString());
            Debug.WriteLine("bytespersec=" + wavhdr.bytespersec.ToString());
            Debug.WriteLine("blocksize=" + wavhdr.blocksize.ToString());
            Debug.WriteLine("bitspersample=" + wavhdr.bitspersample.ToString());

            for (int i = offset + size; i < bs.Length; i++)
            {
                bs[i] = 0;
            }



            Kakunin(inputwav);

#if true
            SubRand(ref bs, offset,size);
            SubRnomi(ref bs, offset, size);

            SubSin(ref bs, offset, size, (int)wavhdr.bytespersec);
            SubPyu(ref bs, offset, size, (int)wavhdr.bytespersec);

            SubKukei(ref bs, offset, size, (int)wavhdr.bytespersec);
            SubKukeiSagari(ref bs, offset, size, (int)wavhdr.bytespersec);

            SubSH(ref bs, offset, size, (int)wavhdr.bytespersec);
//            SubIchion(ref bs, offset, size, (int)wavhdr.bytespersec);

            SubHosoiMado(ref bs, offset, size, (int)wavhdr.bytespersec);
            SubBai(ref bs, offset, size, (int)wavhdr.bytespersec);

            SubChi(ref bs, offset, size, (int)wavhdr.bytespersec,true,1.0,"chi1.wav");
            SubChi(ref bs, offset, size, (int)wavhdr.bytespersec,false,0.43,"chi2.wav");

            // ゲーム用
            SubPoon(ref bs, offset, size, (int)wavhdr.bytespersec,wavhdr);
#endif



        }

        static void Main(string[] args)
        {
            //  Sample.wavを読んでいろいろいじって書き出し
            Iroiro();

            //  簡易シケンサーで作って書き出し
            TestSeq(0, false);   //  doremi
            TestSeq(4, false);  // kaeru
            TestSeq(0, true);    // 連続音
            //            TestSeq(1, true);
            //            TestSeq(2, true);
            TestSeq(3, true);
        }
    }
}
